import matplotlib.pyplot as plt

def peres_vers_fils(p):
    f = {}
    for x in p: f[x] = []
    for x in p:
        if p[x] != x: f[p[x]].append(x)
    return f

def hauteur(fils, k=1):
    if fils[k] == []: return 1
    else:
        return max([hauteur(fils, j) for j in fils[k]]) + 1

def nombre_feuilles(fils, k):
    if fils[k] == []: return 1
    else:
        s = 0
        for j in fils[k]:
            s = s + nombre_feuilles(fils, j)
        return s

def draw_aux(fils, k, rect, dy):
    x1, x2, y1, y2 = rect
    xm = (x1 + x2) // 2
    plt.text(xm + 3, y2, str(k), fontsize=10, horizontalalignment='left',verticalalignment='bottom')
    n = len(fils[k])
    if n > 0:
        nf = nombre_feuilles(fils, k)
        dx = (x2 - x1) // n
        x = x1
        for j in fils[k]:
            u = x
            v = x + nombre_feuilles(fils, j) * (x2 - x1) // nf
            x = v
            draw_aux(fils, j, (u, v, y1, y2 - dy), dy)
            a, b = (xm, (u + v) // 2), (y2, y2 - dy)
            plt.plot(a, b, 'k')
            plt.plot(a, b, 'ro', markersize=4)

def draw(f):
    d = 512
    pad = 20
    dy = (d - 2 * pad) / (hauteur(f))
    draw_aux(f, 1, (pad, d - pad, pad, d - pad), dy)
    plt.axis([0, d, 0, d])
    plt.axis('off')
    plt.show()

def dessin_puissances(t):
    draw(peres_vers_fils(t))
    plt.show()

